package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EVidiconInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EWorkBookBo;
import org.dromara.elevator.domain.vo.EWorkBookVo;
import org.dromara.elevator.domain.EWorkBook;
import org.dromara.elevator.mapper.EWorkBookMapper;
import org.dromara.elevator.service.IEWorkBookService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 工作手册;Service业务层处理
 *
 * @author zy
 * @date 2024-07-29
 */
@RequiredArgsConstructor
@Service
public class EWorkBookServiceImpl implements IEWorkBookService {

    private final EWorkBookMapper baseMapper;

    /**
     * 查询工作手册;
     *
     * @param id 主键
     * @return 工作手册;
     */
    @Override
    public EWorkBookVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询工作手册;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 工作手册;分页列表
     */
    @Override
    public TableDataInfo<EWorkBookVo> queryPageList(EWorkBookBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EWorkBook> lqw = buildQueryWrapper(bo);
        Page<EWorkBookVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的工作手册;列表
     *
     * @param bo 查询条件
     * @return 工作手册;列表
     */
    @Override
    public List<EWorkBookVo> queryList(EWorkBookBo bo) {
        LambdaQueryWrapper<EWorkBook> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EWorkBook> buildQueryWrapper(EWorkBookBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EWorkBook> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getOrganizationId()), EWorkBook::getOrganizationId, bo.getOrganizationId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), EWorkBook::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getSort()), EWorkBook::getSort, bo.getSort());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), EWorkBook::getContent, bo.getContent());
        lqw.orderByDesc(EWorkBook::getCreateTime);
        return lqw;
    }

    /**
     * 新增工作手册;
     *
     * @param bo 工作手册;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EWorkBookBo bo) {
        EWorkBook add = MapstructUtils.convert(bo, EWorkBook.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改工作手册;
     *
     * @param bo 工作手册;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EWorkBookBo bo) {
        EWorkBook update = MapstructUtils.convert(bo, EWorkBook.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EWorkBook entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除工作手册;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
